<?php

include('config.inc.php');

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);


$action = isset($_GET['act']) ? $_GET['act'] : '';
$termId = isset($_GET['termId']) ? intval($_GET['termId']) : 0;
$termIdsStr = isset($_GET['termIds']) ? $_GET['termIds'] : '';

// if ($action != 'cancel' && (!$termId && !$termIdsStr))
{
    // exit();
}

$result = array('code' => 0, 'data' => array());

$termIds = array();
if (!empty($termIdsStr))
{
    $termIds = explode('-', $termIdsStr);
}
else
{
    $termIds[] = $termId;
}

if ($action == 'cancel')
{
    $id = isset($_GET['id']) ? intval($_GET['id']) : 0;
    
    $sql = "DELETE FROM mntn_cmds WHERE `id`=:id LIMIT 1";
    $stmt1 = $db->prepare($sql);

    $sql = "INSERT INTO mntn_cmd_history(`id`,term_id,`name`,`cmd`,`desc`,`status`,`create_time`,`publish_time`) SELECT `id`,`term_id`,`name`,`cmd`,`desc`,2,create_time,NOW() FROM mntn_cmds WHERE `id`=:id";
    $stmt2 = $db->prepare($sql);

    $res2 = $stmt2->execute(array('id' => $id));
    $res1 = $stmt1->execute(array('id' => $id));
    header ('Sql: ' . $sql . $id);
    if (!$res2 || !$res1)
    {
        print_r($stmt1->errorInfo());
    }

    $result['data'][] = $id;
}
else if ($action == 'clear')
{
    $sql = "DELETE FROM mntn_cmds";
    $stmt1 = $db->prepare($sql);

    $sql = "INSERT INTO mntn_cmd_history(`id`,term_id,`name`,`cmd`,`desc`,`status`,`create_time`,`publish_time`) SELECT `id`,`term_id`,`name`,`cmd`,`desc`,2,create_time,NOW() FROM mntn_cmds";
    $stmt2 = $db->prepare($sql);

    $res2 = $stmt2->execute();
    $res1 = $stmt1->execute();
    // header ('Sql: ' . $sql . $id);
    if (!$res2 || !$res1)
    {
        print_r($stmt1->errorInfo());
    }

    $result['data'] = $stmt1->rowCount();
}
else if ($action == 'clearHis')
{
    $sql = "UPDATE mntn_cmd_history SET `status`=0";
    $stmt = $db->prepare($sql);

    $res = $stmt->execute();
 
    $result['data'] = $stmt->rowCount();
}
else if ($action == 'mntn')
{
    $mntnMode = isset($_GET['mntn']) ? intval($_GET['mntn']) : 0;
    // $quickHeartbeat = isset($_GET['quickhb']) ? intval($_GET['quickhb']) : 0;

    // header("qhb:" . $quickHeartbeat);
    header("mntn:" . $mntnMode);

    $sql = "UPDATE mntn_status SET `in_maintain`=:mntn,`mode_time`=CURRENT_TIMESTAMP() WHERE term_id=:termId";
    $stmt3 = $db->prepare($sql);

    foreach($termIds as $termId)
    {
        $res = $stmt3->execute(array('termId' => $termId, 'mntn' => $mntnMode));
        if (!$res)
        {
            print_r($stmt3->errorInfo());
        }

        $result['data'][] = $termId;
    }
}
else if ($action == 'quickhb')
{
    $quickHeartbeat = isset($_GET['quickhb']) ? intval($_GET['quickhb']) : 0;

    header("qhb:" . $quickHeartbeat);
    
    $sql = "UPDATE mntn_status SET `quick_hb`=:qhb,`mode_time`=CURRENT_TIMESTAMP() WHERE term_id=:termId";
    $stmt3 = $db->prepare($sql);

    foreach($termIds as $termId)
    {
        $res = $stmt3->execute(array('termId' => $termId, 'qhb' => $quickHeartbeat));
        if (!$res)
        {
            print_r($stmt3->errorInfo());
        }

        $result['data'][] = $termId;
    }
}
else
{
    $sql = "DELETE FROM mntn_cmds WHERE term_id=:termid AND `name`=:cmdName LIMIT 1";
    $stmt1 = $db->prepare($sql);

    $sql = "INSERT INTO mntn_cmds(term_id,`name`,`cmd`,`desc`) VALUES(:termId,:cmdName,:cmd,:cmdDesc)";
    $stmt2 = $db->prepare($sql);

    foreach($termIds as $termId)
    {
        $termId = intval($termId);

        $values = array('termId' => $termId, 'cmd' => '', 'cmdDesc' => '', 'cmdName' => '');
        
        if ($action == 'reset')
        {
            $values['cmdName'] = 'yw_cmd_android_reboot';
        }
        else if ($action == 'reset-mcu')
        {
            $values['cmdName'] = 'yw_cmd_mcu_reboot';
        }
        else if ($action == 'upload-logs')
        {
            $values['cmdName'] = 'yw_cmd_upload_i1_zip_log';
            $values['cmd'] = json_encode(array('url' => $_GET['url']));
        }
        else if ($action == 'set-cma')
        {
            $values['cmdName'] = 'i1_cmd_set_i1_server_ip_port';
            $values['cmd'] = json_encode(array('value_str' => $_GET['ip'], 'value_int' => intval($_GET['port'])));
        }
        else if ($action == 'set-mntn')
        {
            $values['cmdName'] = 'i1_cmd_set_xy_yw_ip_port';
            $values['cmd'] = json_encode(array('value_str' => $_GET['ip'], 'value_int' => intval($_GET['port'])));
        }
        else if ($action == 'set-hb')
        {
            $values['cmdName'] = 'i1_cmd_set_i1_heart_beat_time';
            $values['cmd'] = json_encode(array('value_int' => intval($_GET['hb'])));
        }
        else if ($action == 'upgrade')
        {
            $values['cmdName'] = 'upgrade';
            $md5 = empty($_GET['md5']) ? '' : $_GET['md5'];
            $fileName = empty($_GET['fn']) ? '' : $_GET['fn'];
            $values['cmd'] = json_encode(array('url' => $_GET['url'], 'md5' => $md5, 'fileName' => $fileName));
        }
        else if ($action == 'upd-ota')
        {
            $values['cmdName'] = 'yw_upd_ota';
            $md5 = empty($_GET['md5']) ? '' : $_GET['md5'];
            $fileName = empty($_GET['fn']) ? '' : $_GET['fn'];
            $values['cmd'] = json_encode(array('url' => $_GET['url'], 'md5' => $md5, 'fileName' => $fileName));
        }
        else if ($action == 'start-frpc')
        {
            $values['cmdName'] = 'yw_cmd_start_frpc';
            // $frpc['cmd_state'] = 1;
            $frpc['server_addr'] = empty($_GET['server_addr']) ? '' : $_GET['server_addr'];
            $frpc['server_port'] = empty($_GET['server_port']) ? '0' : intval($_GET['server_port']) . '';
            $frpc['frpc_type'] = empty($_GET['frpc_type']) ? '' : $_GET['frpc_type'];
            $frpc['type'] = empty($_GET['type']) ? '' : $_GET['type'];
            $frpc['local_ip'] = empty($_GET['local_ip']) ? '' : $_GET['local_ip'];
            $frpc['local_port'] = empty($_GET['local_port']) ? '0' : intval($_GET['local_port']) . '';
            $frpc['remote_port'] = empty($_GET['remote_port']) ? '0' : intval($_GET['remote_port']) . '';

            $frpc_str = json_encode($frpc);
            
            $values['cmd'] = json_encode(array('frpc' => $frpc));
        }
        else if ($action == 'stop-frpc')
        {
            $values['cmdName'] = 'yw_cmd_stop_frpc'; 
        }
        else if ($action == 'stop-aging-test')
        {
            $values['cmdName'] = 'i1_cmd_stop_aging_test'; 
        }
        else
        {
            // continue;
        }

        if (!empty($action))
        {
            $res = $stmt1->execute(array('termid' => $termId, 'cmdName' => $values['cmdName']));
            if (!$res)
            {
                // print_r($stmt1->errorInfo());
            }

            $res = $stmt2->execute($values);
            
            if (!$res)
            {
                // print_r($stmt2->errorInfo());
            }
        }

        if ($res)
        {
            $result['data'][] = $termId;
        }
        
        // i1_cmd_set_i1_server_ip_port //参数 value_str:ip   value_int:port
        // i1_cmd_set_xy_yw_ip_port     //参数 value_str:ip   value_int:port
        // i1_cmd_set_i1_heart_beat_time ////参数   value_int:心跳间隔

    }
}



header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
// $result['code'] = $res ? 0 : 1;
echo json_encode($result, JSON_UNESCAPED_UNICODE);
