<?php

include('config.inc.php');

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);

$result = array('res' => 0, 'data' => array());

$action = empty($_GET['act']) ? '' : $_GET['act'];

if ($action == 'list')
{
  $sql = "SELECT `id`,`title`,term_count AS termCount,create_time AS createTime,update_time AS updateTime";
  $sql .= " FROM mntn_activities";
  $sql .= " WHERE `status`=1 ORDER BY `id` DESC";
  $stmt = $db->prepare($sql);
  $stmt->execute();
  
  $result['data'] = $stmt->fetchAll();
  $stmt = null;
}
else if ($action == 'detail')
{
  $id = empty($_GET['id']) ? 0 : intval($_GET['id']);

  $sql = "SELECT `id`,`title`,term_count AS termCount,create_time AS createTime,update_time AS updateTime";
  $sql .= " FROM mntn_activities";
  $sql .= " WHERE `id`=:id ORDER BY `id` DESC";
  $stmt = $db->prepare($sql);
  $stmt->execute(array('id' => $id));
  
  $result['data']['activity'] = $stmt->fetch();
  $stmt = null;

  $sql = "SELECT t1.`id` AS termId,t1.cmdid,t1.`display_name` AS displayName,t1.`protocol`,t2.`name` AS tower_name,t3.`name` AS line_name";
  $sql .= " FROM terminals AS t1 JOIN towers AS t2 ON t1.tower_id=t2.id JOIN `lines` AS t3 ON t2.line_id=t3.id JOIN mntn_activity_terminals AS t4 ON t1.id=t4.term_id";
  $sql .= " WHERE t4.activity_id=:id";
  $stmt = $db->prepare($sql);
  $stmt->execute(array('id' => $id));

  // header ('Sql: ' . $sql . ' ' . $id);
  
  $result['data']['terms'] = $stmt->fetchAll();
  $stmt = null;
}

header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
echo json_encode($result, JSON_UNESCAPED_UNICODE);
