<?php

include('config.inc.php');

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);

$action = isset($_GET['act']) ? $_GET['act'] : '';

if ($action == 'q')
{
    $cmdid = isset($_GET['cmdid']) ? $_GET['cmdid'] : '';

    $result = array('code' => 0, 'data' => array());

    if (isset($_GET['mntn']) && $_GET['mntn'] == 1)
    {
        $values['cmdName'] = 'upd_cfg';

        $sql = "SELECT `id` FROM terminals WHERE cmdid=:cmdid LIMIT 1";
        $stmt = $db->prepare($sql);
        $stmt->execute(array('cmdid' => $cmdid));
        $terminal = $stmt->fetch();
        
        if ($terminal)
        {
            $termId = $terminal['id'];
            $sql = "DELETE FROM mntn_cmds WHERE term_id=:termid AND `name`=:cmdName LIMIT 1";
            $stmt1 = $db->prepare($sql);

            $sql = "INSERT INTO mntn_cmds(term_id,`name`,`cmd`,`desc`) VALUES(:termId,:cmdName,:cmd,:cmdDesc)";
            $stmt2 = $db->prepare($sql);

            $path_parts = pathinfo($_GET['filename']);

            $idx = 0;
            $cmd = array();
            $cmd['path'] = $path_parts['dirname'];
            $cmd['fileName'] = $path_parts['basename'];
            
            $configs = array();
            foreach ($_GET['cfgName'] as $cfgName)
            {
                if (empty($cfgName))
                {
                    $idx++;
                    continue;
                }
                
                $cfg = array();
                
                $cfg['name'] = $cfgName;
                $cfg['type'] = intval($_GET['cfgType'][$idx]);
                if (strlen($_GET['cfgValue'][$idx]) == 0)
                {
                    $cfg['value'] = null;
                }
                else
                {
                    if ($cfg['type'] == 0)
                    {
                        $cfg['value'] = intval($_GET['cfgValue'][$idx]);
                    }
                    else if ($cfg['type'] == 1)
                    {
                        $cfg['value'] = strval($_GET['cfgValue'][$idx]);
                    }
                    else if ($cfg['type'] == 2)
                    {
                        $cfg['value'] = floatval($_GET['cfgValue'][$idx]);
                    }
                }
                
                $configs[] = $cfg;
                $idx++;
            }
            $cmd['configs'] = $configs;
            if (!empty($_GET['packageName']))
            {
                $cmd['packageName'] = $_GET['packageName'];
            }

            $values = array('termId' => $termId, 'cmd' => json_encode($cmd), 'cmdDesc' => '修改配置', 'cmdName' => 'upd_cfg');

            if (!empty($action))
            {
                $res = $stmt1->execute(array('termid' => $termId, 'cmdName' => $values['cmdName']));
                if (!$res)
                {
                    // print_r($stmt1->errorInfo());
                }

                $res = $stmt2->execute($values);
                
                if (!$res)
                {
                    // print_r($stmt2->errorInfo());
                }
            }

            if ($res)
            {
                $result['data'][] = $termId;
            }
        }
        else
        {
            echo "false";
        }
    }
    else
    {
        // http://dev.xinyingpower.com:40101/web/api/queryCfg.php?act=q&filename=data%2Fchannels%2F1.json
        $path = str_replace('com.xypower.mpapp/', '', $_GET['filename']);
        $cmd = $config['xympadmn_path'] . ' --act=cfg --server=' . $config['cma_server'] . ' --port=' . $config['cma_port'] .' --cmdid="' . $cmdid . '" --pathType=1 --updateType=0 --path="' . $path . '"';
        // --name1=osd.leftTop --type1=1 --value1="OSD for LeftTop %%CH%%" --name2=osd.rightTop --type2=255 --value2="OSD for rIGHTTop %%CH%%" --name3=usbCamera --type3=0 --value3=1 --clientid=5 --reqid=TS';

        if (!apcu_exists('xympadmn.requestid'))
        {
            apcu_store('xympadmn.requestid', time());
        }

        $requestId = apcu_inc('xympadmn.requestid');
        
        $cmd .= ' --clientid=' . $config['clientId'] . ' --reqid=' . $requestId;
        header('Cmd:' . $cmd);

        $result_code = 1;
        $res = exec($cmd, $output, $result_code);
        if ($res !== false && $result_code === 0)
        {
            $result['clientId'] = $config['clientId'];
            $result['requestId'] = $requestId;
        }
        else
        {
            $result['code'] = 1;
        }
    }
}
else
{
    $clientId = intval($_GET['clientId']);
    $requestId = intval($_GET['reqId']);

    $sql = 'SELECT * FROM request_results WHERE client_id=:clientId AND request_id=:reqId';
    
    $stmt = $db->prepare($sql);
    $stmt->execute(array('clientId' => $clientId, 'reqId' => $requestId));
    $row = $stmt->fetch();
    
    if (isset($row['data']))
    {
        $row['data'] = json_decode($row['data'], true);

        if (isset($row['data']['content']))
        {
            $row['data']['content'] = json_decode(base64_decode($row['data']['content']), true);
        }
    }
    $result['data'] = $row;
}


header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
// $result['code'] = $res ? 0 : 1;
echo json_encode($result, JSON_UNESCAPED_UNICODE);
