<?php

include('config.inc.php');

$queryType = empty($_GET['qt']) ? 'pending' : 'his';
$page = isset($_GET['p']) ? intval($_GET['p']) : 1;
$pageSize = isset($_GET['ps']) ? intval($_GET['ps']) : 20;
if ($pageSize <= 0) $pageSize = 20;

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);

$result = array('res' => 0, 'data' => array());

$tableName = ($queryType == 'pending') ? 'mntn_cmds' : 'mntn_cmd_history';

$sql = 'SELECT COUNT(*) AS cnt FROM ' . $tableName;
$stmt = $db->prepare($sql);
$res = $stmt->execute();
$row = $stmt->fetch();
$stmt = null;
if (!$row)
{
    header ('SqlCnt: ' . $sql);
    echo json_encode($result);
    exit;
}
$numberOfRows = $row['cnt'];
$numberOfPages = ceil(($numberOfRows + $pageSize - 1) / $pageSize);
if ($page > $numberOfPages)
{
    $page = $numberOfPages;
}

$result['page'] = array('page' => 1, 'pageSize' => $pageSize, "totalPages" => $numberOfPages, "totalRecords" => $numberOfRows);

if ($queryType == 'pending')
{
    $sql = 'SELECT t1.cmdid,t1.`display_name` AS displayName,t2.`name` AS cmdName,t2.`cmd`,t2.`desc` AS cmdDesc,t2.`create_time` AS createTime,t2.term_id AS termId,t2.`id`,t3.raw_report_time AS prevReportTime FROM ' . $tableName . ' AS t2 JOIN terminals AS t1 ON t2.term_id=t1.`id` JOIN mntn_status AS t3 ON t2.term_id=t3.term_id ORDER BY t2.`id` DESC LIMIT ' . (($page - 1) * $pageSize) . ',' . $pageSize;
}
else
{
    $sql = 'SELECT t1.cmdid,t1.`display_name` AS displayName,t2.`name` AS cmdName,t2.`cmd`,t2.`status`,t2.`create_time` AS createTime,t2.publish_time AS publishTime, t2.term_id AS termId,t2.`id` FROM ' . $tableName . ' AS t2 JOIN terminals AS t1 ON t2.term_id=t1.`id` WHERE t2.`status`=1 ORDER BY t2.`id` DESC LIMIT ' . (($page - 1) * $pageSize) . ',' . $pageSize;
}
$stmt = $db->prepare($sql);
$res = $stmt->execute();
if (!$res)
{
    header ('Sql: ' . $sql);
    echo json_encode($result);
    exit;
}

$result['data'] = $stmt->fetchAll();
$stmt = null;

$obj = new \stdClass;
foreach ($result['data'] as &$item)
{
    if (!empty($item['cmd']))
    {
      $item['cmd'] = json_decode($item['cmd'], true);
    }
    else
    {
        $item['cmd'] = $obj;
    }
    
    if (isset($item['prevReportTime']))
    {
        $hb = apcu_fetch('mntn_hb.' . $item['termId']);
        if ($hb !== false && $hb !== 0)
        {
            $item['estimatedPublishTime'] = $item['prevReportTime'] + $hb;
        }
        else
        {
            $item['estimatedPublishTime'] = 0;
        }
    }
}
unset($item);

header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
echo json_encode($result, JSON_UNESCAPED_UNICODE);
