<?php

include('config.inc.php');
include('cmd.inc.php');

$result = array('res' => 0, 'data' => array());

$termId = isset($_GET['termId']) ? intval($_GET['termId']) : 0;
if (empty($termId))
{
  echo json_encode($result);
  exit;
}

$values = array('tid' => $termId);

$page = isset($_GET['p']) ? intval($_GET['p']) : 1;
$pageSize = isset($_GET['ps']) ? intval($_GET['ps']) : 20;
if ($pageSize <= 0) $pageSize = 20;

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);

$sql = 'SELECT COUNT(*) AS cnt FROM mntn_raw_reports WHERE `term_id`=:tid';
$stmt = $db->prepare($sql);
$res = $stmt->execute($values);
$row = $stmt->fetch();
$stmt = null;
if (!$row)
{
    header ('SqlCnt: ' . $sql);
    echo json_encode($result);
    exit;
}
$numberOfRows = $row['cnt'];
$numberOfPages = ceil(($numberOfRows + $pageSize - 1) / $pageSize);
if ($page > $numberOfPages)
{
    $page = $numberOfPages;
}

$result['page'] = array('page' => 1, 'pageSize' => $pageSize, "totalPages" => $numberOfPages, "totalRecords" => $numberOfRows);

$sql = 'SELECT t1.cmdid,t1.`display_name` AS displayName,t1.`protocol`,t2.`name` AS tower_name,t3.`name` AS line_name, t4.`id`,t4.term_id,t4.content,t4.`id`,t4.`ip`,FROM_UNIXTIME(t4.create_time) AS createTime';
$sql .= ' FROM mntn_raw_reports AS t4 JOIN terminals AS t1 ON t4.term_id=t1.`id` JOIN towers AS t2 ON t1.tower_id=t2.id JOIN `lines` AS t3 ON t2.line_id=t3.id';
$sql .= ' WHERE t4.`term_id`=:tid ORDER BY t4.`id` DESC LIMIT ' . (($page - 1) * $pageSize) . ',' . $pageSize;
$stmt = $db->prepare($sql);
$stmt->execute($values);

$result['data'] = $stmt->fetchAll();
$stmt = null;

$obj = new \stdClass;
foreach ($result['data'] as &$row)
{
    $msgs = array();
    if (empty($row['content']))
    {
        $row['raw_report'] = $obj;
    }
    else
    {
        $row['raw_report'] = json_decode($row['content'], true);
        if (!empty($row['raw_report']['msg']))
        {
            $msgs = parseCmd($row['raw_report']['msg']);
        }

        $row['raw_report']['msgs'] = $msgs;
    }
}
unset($row);

header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
echo json_encode($result, JSON_UNESCAPED_UNICODE);
