<?php

include('config.inc.php');
include('cmd.inc.php');

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);

$result = array('res' => 0, 'data' => array());
$conditions = array();
$values = array();
$orderField = '';
// 筛选接口  与的关系    查询的字段分别是出厂ID(oid)、装置编号（cmdid）、CMA服务器（cma）、版本信息（aiVersion、i1Version、maintainVersion、cameraService），并且每个筛选条件后面都带checbox框   勾选上定义的值为1  未勾选定义的为0，  然后点击搜索筛选 

// true: if value is not set, will ignored
$filterFields = array('cmdid', 'oid', 'cma', 'version', 'activity', 'protocol', 'mntned');

$filters = array();
if (isset($_GET['fc']) && $_GET['fc'] == intval($_GET['fc']))
{
    $numberOfFilters = intval($_GET['fc']);
    for ($idx = 1; $idx <= $numberOfFilters; $idx++)
    {
        if (empty($_GET['fn' . $idx]) || !isset($_GET['fv' . $idx]) || $_GET['fv' . $idx] == '' || !in_array($_GET['fn' . $idx], $filterFields))
        {
            continue;
        }
        $filterName = $_GET['fn' . $idx];
        $filterValue = $_GET['fv' . $idx];

        // echo $filterName;

        $filterReverse = isset($_GET['frev' . $idx]) ? ($_GET['frev' . $idx] != '0') : false;

        $filters[$filterName] = array('val' => $filterValue, 'rev' => $filterReverse);
    }
}

if (isset($_GET['of']))
{
    $orderField = $_GET['of'];
}

if (isset($_GET['towerId']) && intval($_GET['towerId']) > 0)
{
    $conditions[] = "t2.`id`=:towerid";
    $values['towerid'] = intval($_GET['towerId']);
}
else if (isset($_GET['lineId']) && intval($_GET['lineId']) > 0)
{
    $conditions[] = "t3.`id`=:lineid";
    $values['lineid'] = intval($_GET['lineId']);
}
if (isset($filters['cmdid']))
{
    $conditions[] = $filters['cmdid']['rev'] ? "t1.`cmdid` NOT LIKE :cmdid" : "t1.`cmdid` LIKE :cmdid";
    $values['cmdid'] = '%' . $filters['cmdid']['val'] . '%';
}

if (isset($filters['activity']) && !empty($filters['activity']['val']))
{
    $notClause = $filters['activity']['rev'] ? ' NOT ' : '';
    $conditions[] = 't1.`id` ' . $notClause . ' IN (SELECT term_id FROM mntn_activity_terminals WHERE `activity_id`=:activityId)';
    $values['activityId'] = $filters['activity']['val'];
}
if (isset($filters['protocol']) && !empty($filters['protocol']['val']))
{
    $notClause = $filters['protocol']['rev'] ? '<>' : '=';
    $conditions[] = 't1.`protocol`' . $notClause . ':protocol';
    $values['protocol'] = $filters['protocol']['val'];
}

if (isset($filters['mntned']) && !empty($filters['mntned']['val']))
{
    $notClause = (intval($filters['mntned']['val']) == 1) ? '<>' : '=';
    $conditions[] = 't4.`raw_report_time`' . $notClause . '0';
}
// $conditions[] = "t4.`term_id` IN (SELECT term_id FROM mntn_activity_terminals WHERE `activity_id`=10001)";
$conditionStr = '';
if (count($conditions) > 0)
{
    $conditionStr = ' WHERE ' . implode(' AND ', $conditions);
}

$sql = "SELECT t1.id, t1.cmdid,t1.`display_name`,t1.`protocol`,t1.bs_identifier AS `oid`,t2.`name` AS tower_name,t3.`name` AS line_name,t4.last_raw_report AS raw_report,t4.raw_report_time AS last_heartbeat_ts,FROM_UNIXTIME(t4.raw_report_time) AS last_heartbeat,t4.last_ip,t4.in_maintain,t4.quick_hb,t4.mode_time,t4.comment";
$sql .= " FROM terminals AS t1 JOIN towers AS t2 ON t1.tower_id=t2.id JOIN `lines` AS t3 ON t2.line_id=t3.id";
$sql .= " LEFT JOIN mntn_status AS t4 ON t1.id=t4.term_id " . $conditionStr;
if (empty($orderField))
{
    $sql .= " ORDER BY t2.line_id,t2.`order`,t1.cmdid";
}
$stmt = $db->prepare($sql);
$stmt->execute($values);

header ('Sql: ' . $sql);

$result['data'] = array();
$rows = $stmt->fetchAll();
$stmt = null;

$obj = new \stdClass;
foreach($rows as &$row)
{
    $msgs = array();
    $row['last_heartbeat_time'] = empty($row['last_heartbeat']) ? '' : substr($row['last_heartbeat'], 11);
    if (empty($row['raw_report']))
    {
        $row['raw_report'] = array();
    }
    else
    {
        $row['raw_report'] = json_decode($row['raw_report'], true);
        if (!empty($row['raw_report']['msg']))
        {
            $msgs = parseCmd($row['raw_report']['msg']);
        }
    }

    if (!is_object($row['raw_report']) && !empty($row['raw_report']['oid']) && empty($row['oid']))
    {
        $row['oid'] = $row['raw_report']['oid'];
    }
    else if (is_null($row['oid']))
    {
        $row['oid'] = '';
    }

    // Filter 
    if (isset($filters['oid']))
    {
        $pos = strpos($row['oid'], $filters['oid']['val']);
        if (($filters['oid']['rev'] && ($pos !== false)) || (!$filters['oid']['rev'] && ($pos === false)))
        {
            // ignored
            continue;
        }
    }
    
    if (isset($filters['cma']))
    {
        if (empty($msgs['cma']))
        {
            $msgs['cma'] = '';
        }
        $pos = strpos($msgs['cma'], $filters['cma']['val']);
        if (($filters['cma']['rev'] && ($pos !== false)) || (!$filters['cma']['rev'] && ($pos === false)))
        {
            continue;
        }
    }
    if (isset($filters['version']))
    {
        // aiVersion、i1Version、maintainVersion、cameraService
        $allVersions = (empty($msgs['aiVersion']) ? '' : $msgs['aiVersion']) . "\n" . (empty($msgs['i1Version']) ? '' : $msgs['i1Version']) . "\n" . (empty($msgs['maintainVersion']) ? '' : $msgs['maintainVersion']) . "\n" . (empty($msgs['cameraService']) ? '' : $msgs['cameraService']) . "\n" . (empty($msgs['mcu']) ? '' : $msgs['mcu']);
        $pos = strpos($allVersions, $filters['version']['val']);
        if (($filters['version']['rev'] && ($pos !== false)) || (!$filters['version']['rev'] && ($pos === false)))
        {
            continue;
        }
    }

    $row['raw_report']['msgs'] = $msgs;
    $result['data'][] = $row;
}
unset($row);
$desc = false;
if (isset($_GET['asc']))
{
    $desc = ($_GET['asc'] != 0);
}

function cmp($a, $b)
{
    global $orderField;
    global $desc;

    $ret = 0;
    if ($orderField == 'cmdid' || $orderField == 'oid' || $orderField == 'protocol')
    {
        $ret = strcmp($a[$orderField], $b[$orderField]); 
    }
    else if ($orderField == 'mntn')
    {
        $ret = strcmp($a['in_maintain'], $b['in_maintain']); 
    }
    else if ($orderField == 'hb')
    {
        $ret = strcmp($a['last_heartbeat_ts'], $b['last_heartbeat_ts']); 
    }
    else if ($orderField == 'imgs')
    {
        $imgs1 = isset($a['raw_report']['msgs']['last_heartbeat_ts']) ? $a['raw_report']['msgs']['last_heartbeat_ts'] : 0;
        $imgs2 = isset($b['raw_report']['msgs']['last_heartbeat_ts']) ? $b['raw_report']['msgs']['last_heartbeat_ts'] : 0;
        $ret = ($imgs1 == $imgs2) ? 0 : (($imgs1 < $imgs2) ? -1 : 1); 
    }
    
    if ($desc && $ret != 0)
    {
        $ret = ($ret < 0) ? 1 : -1;
    }
    
    return $ret;
}

if (!empty($orderField))
{
    usort($result['data'], 'cmp');
}

$result['termCount'] = count($result['data']);

header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
echo json_encode($result, JSON_UNESCAPED_UNICODE);
