<?php

include('config.inc.php');

$db = new PDO('mysql:host=' . $config['host'] . ';dbname=' . $config['database'], $config['dbuser'], $config['password'], [
    \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
    \PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8mb4'"
  ]);


$action = isset($_POST['act']) ? $_POST['act'] : '';
$cmdid = isset($_POST['cmdid']) ? $_POST['cmdid'] : '';

$result = array('code' => 0, 'data' => array());

if (isset($_POST['mntn']) && $_POST['mntn'] == 1)
{
    $values['cmdName'] = 'upd_cfg';

    $sql = "SELECT `id` FROM terminals WHERE cmdid=:cmdid LIMIT 1";
    $stmt = $db->prepare($sql);
    $stmt->execute(array('cmdid' => $cmdid));
    $terminal = $stmt->fetch();
    
    if ($terminal)
    {
        $termId = $terminal['id'];
        $sql = "DELETE FROM mntn_cmds WHERE term_id=:termid AND `name`=:cmdName LIMIT 1";
        $stmt1 = $db->prepare($sql);

        $sql = "INSERT INTO mntn_cmds(term_id,`name`,`cmd`,`desc`) VALUES(:termId,:cmdName,:cmd,:cmdDesc)";
        $stmt2 = $db->prepare($sql);

        $path_parts = pathinfo($_POST['filename']);

        $idx = 0;
        $cmd = array();
        $cmd['path'] = $path_parts['dirname'];
        $cmd['fileName'] = $path_parts['basename'];
        
        $configs = array();
        foreach ($_POST['cfgName'] as $cfgName)
        {
            if (empty($cfgName))
            {
                $idx++;
                continue;
            }
            
            $cfg = array();
            
            $cfg['name'] = $cfgName;
            $cfg['type'] = intval($_POST['cfgType'][$idx]);
            if (strlen($_POST['cfgValue'][$idx]) == 0)
            {
                $cfg['value'] = null;
            }
            else
            {
                if ($cfg['type'] == 0)
                {
                    $cfg['value'] = intval($_POST['cfgValue'][$idx]);
                }
                else if ($cfg['type'] == 1)
                {
                    $cfg['value'] = strval($_POST['cfgValue'][$idx]);
                }
                else if ($cfg['type'] == 2)
                {
                    $cfg['value'] = floatval($_POST['cfgValue'][$idx]);
                }
            }
            
            $configs[] = $cfg;
            $idx++;
        }
        $cmd['configs'] = $configs;
        if (!empty($_POST['packageName']))
        {
            $cmd['packageName'] = $_POST['packageName'];
        }

        $values = array('termId' => $termId, 'cmd' => json_encode($cmd), 'cmdDesc' => '修改配置', 'cmdName' => 'upd_cfg');

        if (!empty($action))
        {
            $res = $stmt1->execute(array('termid' => $termId, 'cmdName' => $values['cmdName']));
            if (!$res)
            {
                // print_r($stmt1->errorInfo());
            }

            $res = $stmt2->execute($values);
            
            if (!$res)
            {
                // print_r($stmt2->errorInfo());
            }
        }

        if ($res)
        {
            $result['data'][] = $termId;
        }
    }
    else
    {
        echo "false";
    }
}
else
{
    $path = str_replace('com.xypower.mpapp/', '', $_POST['filename']);
    $cmd = $config['xympadmn_path'] . ' --act=cfg --server=' . $config['cma_server'] . ' --port=' . $config['cma_port'] .' --cmdid="' . $cmdid . '" --pathType=1 --updateType=0 --path="' . $path . '"';
    // --name1=osd.leftTop --type1=1 --value1="OSD for LeftTop %%CH%%" --name2=osd.rightTop --type2=255 --value2="OSD for rIGHTTop %%CH%%" --name3=usbCamera --type3=0 --value3=1 --clientid=5 --reqid=TS';

    if (!empty($_POST['packageName']))
    {
        $cmd .= ' --reboot=1';
    }
    
    if (!apcu_exists('xympadmn.requestid'))
    {
        apcu_store('xympadmn.requestid', time());
    }


    $requestId = apcu_inc('xympadmn.requestid');

    $idx = 0;
    $configs = '';    
    foreach ($_POST['cfgName'] as $cfgName)
    {
        if (empty($cfgName))
        {
            $idx++;
            continue;
        }

        $cfgType = intval($_POST['cfgType'][$idx]);

        $configs .= ' --name' . ($idx + 1) . '="' . $cfgName . '" --type' . ($idx + 1) . '=' . intval($_POST['cfgType'][$idx]) . ' --value' . ($idx + 1) . '=';
        
        if ($cfgType == 0)
        {
            $configs .= intval($_POST['cfgValue'][$idx]);
        }
        else if ($cfgType == 1)
        {
            $configs .= '"' . strval($_POST['cfgValue'][$idx]) . '"';
        }
        else if ($cfgType == 2)
        {
            $configs .= floatval($_POST['cfgValue'][$idx]);
        }
        $idx++;
    }
    
    $cmd .= ' --configs=' . $idx . $configs . ' --clientid=' . $config['clientId'] . ' --reqid=' . $requestId;
    header('Cmd:' . $cmd);

    $result_code = 1;
    $res = exec($cmd, $output, $result_code);
    if ($res !== false && $result_code === 0)
    {
        $result['clientId'] = 11;
        $result['requestId'] = $requestId;
    }
    else
    {
        $result['code'] = 1;
    }
}

header ('Access-Control-Allow-Origin: *');
header ('Content-type: application/json; charset=utf-8');
// $result['code'] = $res ? 0 : 1;
echo json_encode($result, JSON_UNESCAPED_UNICODE);
